<script lang="ts">
import Vue from 'vue';
import {
  EnableReduceMotion,
  IsMobileMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';
import VideoModal from '~/components/solutions/video-modal.vue';

export default Vue.extend({
  name: 'DuoProHero',
  components: {
    VideoModal,
  },
  mixins: [
    IsMobileMixin,
    UseLiteVimeo,
    UseLocalizedVideoSubtitles,
    EnableReduceMotion,
  ],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    video: {
      type: Object,
      required: false,
      default: () => ({
        mp4_url: '/nuxt-images/home/hero.mp4',
        webm_url: '/nuxt-images/home/hero.webm',
      }),
    },
  },
  data: () => ({
    showModal: false,
    videoRefs: ['video'],
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <div class="gitlab-duo">
    <video
      ref="video"
      class="video-looping"
      autoplay
      loop
      muted
      playsinline
      loading="lazy"
      preload="metadata"
    >
      <source :src="video?.mp4_url" type="video/mp4" />
      <source :src="video?.webm_url" type="video/webm" />
    </video>
    <SlpContainer class="gitlab-duo__container">
      <SlpRow class="gitlab-duo__row">
        <SlpColumn :cols="12" class="gitlab-duo__copy gitlab-duo__col">
          <div
            :data-aos="isMobile ? null : 'fade-down'"
            :data-aos-duration="isMobile ? null : '1600'"
            :data-aos-offset="isMobile ? null : '0'"
          >
            <a :href="data.primaryButton.href">
              <img
                src="/nuxt-images/home/GitLab-Duo-Eyebrow.svg"
                class="gitlab-duo__pill"
                alt=""
              />
            </a>
            <SlpTypography
              tag="h1"
              variant="heading3-bold"
              class="slp-mt-16 slp-mb-24"
            >
              {{ data.title }}
            </SlpTypography>
            <SlpButton
              v-if="data.primaryButton"
              variant="secondary"
              :href="data.primaryButton.href"
              :data-ga-name="data.primaryButton.dataGaName"
              :data-ga-location="data.primaryButton.dataGaLocation"
              class="slp-mr-16"
            >
              {{ data.primaryButton.text }}
            </SlpButton>
            <SlpButton
              v-if="data.button"
              variant="tertiary"
              :data-ga-name="data.button.data_ga_name"
              :data-ga-location="data.button.data_ga_location"
              @click.native="openModal()"
            >
              {{ data.button.text }}
              <SlpIcon
                name="play-circle-outline"
                variant="marketing"
                size="md"
              ></SlpIcon>
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
      <VideoModal
        v-show="showModal && data.video?.url"
        light-background
        :visible="showModal"
        @close="showModal = false"
      >
        <template #body>
          <lite-vimeo
            :videoid="getVimeoVideoId(createVideoSource(data.video?.url))"
            title="Video"
            autoplay
          ></lite-vimeo>
        </template>
      </VideoModal>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.video-looping {
  width: 100%;
  height: calc(100vh - 136px);
  object-fit: cover;
  filter: brightness(0.35);

  @media screen and (max-height: 590px) {
    height: 590px;
  }
}

.gitlab-duo {
  color: $color-text-50;
  position: relative;
  line-height: 0%;
  background-color: $color-surface-700;

  &__pill {
    @media screen and (max-width: $breakpoint-lg) {
      max-width: 80vw;
    }
  }

  .duo-logo {
    height: 24px;
  }

  .description {
    color: $color-surface-400;
    max-width: 540px;
  }

  &__row {
    position: absolute;
    transform: translateY(-100%);
    top: 90%;

    @media (min-width: $breakpoint-md) {
      width: 80%;
    }

    @media (min-width: $breakpoint-lg) {
      width: 60%;
    }

    @media (min-width: $breakpoint-2xl) {
      width: 44%;
    }
  }

  &__bg-image {
    width: 100%;
    object-fit: cover;

    @media (max-width: $breakpoint-lg) {
      min-height: 500px;
      object-fit: cover;
    }
  }

  &__col {
    height: 100%;
    min-height: 100%;
    width: 100%;

    @media (max-width: $breakpoint-lg) {
      flex: 1 1 100%;
      width: 100%;
    }
  }

  &__copy {
    z-index: 1000;

    @media (max-width: $breakpoint-md) {
      padding-top: $spacing-96;
    }
  }
}

.slp-btn-tertiary {
  color: $color-text-50;
  padding: $spacing-8 $spacing-16 $spacing-8 0;
  font-size: 18px;

  &:hover {
    text-decoration: underline;

    svg {
      transition: transform 0.4s ease;
      transform: translateX($spacing-8);
    }
  }

  svg {
    margin-left: $spacing-8;
  }
}

.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
